-- Dukla
-- Version 1.01, ENG version
-- Yoky, copyright, 22.12.2004
--
-- Mission: Single
-- Oponents: Soviet (Human), Germany (Computer)
-- ---------------------------------------------------------------

function BeginSet()
	-- ShowActiveScripts();
	-- Password("Panzerklein");
	-- God(0, 1);
	SetIGlobalVar("numbMissionDone", 0);
	DisplayTrace("Area is heavily mined, be careful.");

	Suicide();
end;

function RevealObjective0()
	ObjectiveChanged(0, 0);
	Suicide();
end;

function RevealObjective1()
	ObjectiveChanged(1, 0);
	Suicide();
end;

function RevealObjective2()
	ObjectiveChanged(2, 0);
	Suicide();
end;

function RevealObjective3()
	ObjectiveChanged(3, 0);
	Suicide();
end;

function Objective0()
	local i = 0;
	
	if ((GetNUnitsInScriptGroup(121, 1) == 0) and (GetNUnitsInScriptGroup(122, 1) == 0) and (GetNUnitsInScriptGroup(123, 1) == 0) and (GetNUnitsInScriptGroup(124, 1) == 0) and (GetNUnitsInScriptGroup(125, 1) == 0)) then
		ObjectiveChanged(0, 1);
		--ObjectiveChanged(1, 0);
		
		i = GetIGlobalVar("numbMissionDone", 0);
		i = i + 1;
		SetIGlobalVar("numbMissionDone", i);		
		Suicide();
	end;
end;

function Objective1()
	local i = 0;
	
	if ((GetNUnitsInScriptGroup(101, 1) == 0) and (GetNUnitsInScriptGroup(102, 1) == 0) and (GetNUnitsInScriptGroup(103, 1) == 0) and (GetNUnitsInScriptGroup(104, 1) == 0) and (GetNUnitsInScriptGroup(105, 1) == 0)) then
		ObjectiveChanged(1, 1);
		--ObjectiveChanged(1, 0);
		
		i = GetIGlobalVar("numbMissionDone", 0);
		i = i + 1;
		SetIGlobalVar("numbMissionDone", i);		
		Suicide();
	end;
end;

function Objective2()
	local i = 0;
	
	if (GetNScriptUnitsInArea(10, "PrusmykDukla") > 0) then	
		ObjectiveChanged(2, 1);
		--ObjectiveChanged(1, 0);
		
		i = GetIGlobalVar("numbMissionDone", 0);
		i = i + 1;
		SetIGlobalVar("numbMissionDone", i);		
		Suicide();
	end;
end;

function ToWin()
	if (GetIGlobalVar("numbMissionDone", 0) == 3) then
		ObjectiveChanged(3, 1);
		Win(0);
		Suicide();
	end;
end;

function TobeDefeated()
	if (GetNUnitsInScriptGroup(10, 0) == 0) then
		DisplayTrace("You failed because you were not able to secure your Generals...");
		Loose();
		Suicide();
	end;
	
	if (GetNUnitsInParty(0) < 1) then
		DisplayTrace("You failed because all your units were killed...");
		Loose();
		Suicide();
	end;
end;

-- -------------------------------------------------------
function GermanCounterattack1()
	Cmd(3, 131, 7026, 4444);
	QCmd(3, 131, 6750, 200);
	
	Cmd(3, 135, 6750, 200);
	RunScript("GermanInfUnload1", 1000);
	
	-- Artilery choose smoke shells
	Cmd(46, 143, 1);
	-- Artilery fire
	QCmd(16, 143, 7080, 3080)

	Suicide();
end;

function GermanInfUnload1()
	local x = 0;
	local y = 0;
	
	if (GetNScriptUnitsInArea(131, "germanInfUnload1") > 0) then
		-- Choose Artilery expl. shells, stop Artilery fire
		Cmd(9, 143);
		QCmd(46, 143, 0);
		
		x, y = GetObjCoord(131);
		if (x == -1) then
			Suicide();
		end;
		
		Cmd(5, 131, x, y);
		QCmd(3, 131, 6750, 200);
		
		RunScript("GermanInfAttackOrder", 1500);
		Suicide();
	end;
end;

function GermanInfAttackOrder()
	Cmd(3, 135, 6750, 200);
	Suicide();
end;

-- -------------------------------------------------------
function Obj0Counterattack()
	if (GetNUnitsInScriptGroup(125, 1) < 3) then
		LandReinforcement(155);
		LandReinforcement(151);
		RunScript("Obj0CounterattackOrder", 3000);
		Suicide();
	end;
end;

function Obj0CounterattackOrder()
	Cmd(3, 155, 5800, 3861);
	Cmd(3, 151, 5800, 3861);
	Suicide();
end;

-- -------------------------------------------------------
function RusReinforcement1()
	DisplayTrace("Workshops have repaired more tanks.");
	LandReinforcement(21);
	LandReinforcement(24);
	LandReinforcement(25);
	LandReinforcement(22);
	Suicide();
end;

-- -------------------------------------------------------
-- Main
-- -------------------------------------------------------
function Init()
	RunScript( "BeginSet", 1000);
	RunScript( "RevealObjective0", 2000);
	RunScript( "RevealObjective1", 4000);
	RunScript( "RevealObjective2", 6000);
	RunScript( "RevealObjective3", 8000);
	
	RunScript( "Objective0", 2000);
	RunScript( "Objective1", 2000);
	RunScript( "Objective2", 2000);

	RunScript( "ToWin", 4000);
	RunScript( "TobeDefeated", 4000);
	
	RunScript( "GermanCounterattack1", 180000);
	RunScript( "Obj0Counterattack", 3000);
	RunScript( "RusReinforcement1", 900000);
end;